#include <stdio.h>
#include <stdlib.h>

#include "queue.h"

void Empty(TQUEUE* q){
     q->front=NULL;
     q->rear=NULL;
}

TQUEUE* CreateQueue(){
     TQUEUE* tmp=malloc(sizeof(TQUEUE));
     if(tmp==NULL)return NULL;
     Empty(tmp);
     return tmp;
}

void PrintQueue(TQUEUE *q){
     TNODE *tmp;
     tmp=q->front;
     while(tmp!=NULL){
          printf("%s ",tmp->value);
          tmp=tmp->next;
     }        
     printf("\n");
}

TNODE* CreateNode(TElement v){
     TNODE* tmp=malloc(sizeof(TNODE));
     if(tmp==NULL)return NULL;
     tmp->value=v;
     tmp->next=NULL;
     return tmp;
}

int IsEmpty(TQUEUE* q){
     if(q->front==NULL)return 1;
     else return 0;
}
     
void Enqueue(TQUEUE* q,TNODE* n){
     if(IsEmpty(q)){
        q->front = n;
        q->rear=n;
     } else  {
        q->rear->next = n;
        q->rear = n;
        }
}
            
TNODE* FrontAndDequeue(TQUEUE* q){
         TNODE* tmp;
         if(q->front==NULL)return NULL;
         tmp=q->front;
         q->front=tmp->next;
         tmp->next=NULL;
         if(q->front==NULL)q->rear=NULL;
         return tmp;
}

