typedef  char* TElement;

typedef struct node {
 TElement value;
 struct node *next;
} TNODE;

typedef struct {
   TNODE *front;
   TNODE *rear;
} TQUEUE;

TQUEUE* CreateQueue();
void PrintQueue(TQUEUE *q);
void Empty(TQUEUE* q);
int IsEmpty(TQUEUE* q);
TNODE* CreateNode(TElement v);
void Enqueue(TQUEUE* q,TNODE *x);
TNODE* FrontAndDequeue(TQUEUE* q);

